---
updatedAt: 2026-04-30T11:36:59.000Z
agentTools:
  projectIndex: https://coinify.readme.io/llms.txt
---

# Create quote

<Callout icon="❗️" theme="error">
  # This page is intended only for merchants who want to build their own checkout page UI.

  Otherwise, you can preselect a cryptocurrency for the customer simply by providing the `quoteCurrency` parameter on [Payment Intent creation](https://coinify.readme.io/reference/create-payment-intent).
</Callout>

<Callout icon="👍" theme="okay">
  **The `{paymentIntentiId}` path parameter is the specific Payment Intent ID for which you want to fetch the quote.**
</Callout>

Once a Payment Intent is created, it is possible to make a payment transaction to that PaymentIntent in one of the available cryptocurrencies. While the [Read Currencies](https://coinify.readme.io/reference/payment-intent-read-currencies) endpoint allows you to fetch the list of all available cryptocurrencies for a specific [PaymentIntent](https://coinify.readme.io/reference/payment-intent-overview), the **Create quote** endpoint allows you to retrieve a quote in the selected cryptocurrency for the specific **Payment Intent**.

The **`quote`** object in the response of this endpoint tells you how much of the chosen cryptocurrency needs to be transacted in order to successfully complete the PaymentIntent. Additionally, it also provides you with address where the cryptocurrency funds need to be sent.\
You can find this and other response examples on the right side of this page.

**`refundAddress`** is optional and if not provided, the end-user will be (automatically) asked to provide the refund address via email in cases of [incorrect payments](https://coinify.readme.io/docs/automated-refunds-for-incorrect-payments).\
If the **`refundAddress`** is provided, the end-user will be automatically refunded to the provided address in case the payment is not successful.

**`refundTag`** is necessary only for specific cryptocurrencies that use the destination tag technology like for example Stellar (XLM). You can read more about the [destination tags here](https://help.coinify.com/hc/en-us/articles/360019889500-What-is-destination-tag-memo).

Make sure the Payment Intent ID is provided as the path parameter, along with the mandatory **`currency`**  body parameter.

# OpenAPI definition

```json
{
  "openapi": "3.1.0",
  "info": {
    "title": "payment-intent",
    "version": "1.0"
  },
  "servers": [
    {
      "url": "https://api.payment.sandbox.coinify.com"
    }
  ],
  "components": {
    "securitySchemes": {
      "sec0": {
        "type": "apiKey",
        "in": "header",
        "name": "X-API-KEY",
        "x-default": ""
      }
    }
  },
  "security": [
    {
      "sec0": []
    }
  ],
  "paths": {
    "/v1/payment-intents/{paymentIntentiId}/quotes": {
      "post": {
        "summary": "Create quote",
        "description": "",
        "operationId": "create-payment-intent-quote",
        "parameters": [
          {
            "in": "path",
            "name": "paymentIntentiId",
            "schema": {
              "type": "string"
            },
            "required": true
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "required": [
                  "currency",
                  "walletId"
                ],
                "properties": {
                  "currency": {
                    "type": "string",
                    "description": "The cryptocurrency you want to get the quote in."
                  },
                  "walletId": {
                    "type": "string",
                    "description": "UUID string as returned by the <a href=\"https://coinify.readme.io/reference/create-customer-wallet\">Create Customer Wallet</a> endpoint."
                  },
                  "refundAddress": {
                    "type": "string",
                    "description": "Address for refunds."
                  },
                  "refundTag": {
                    "type": "string",
                    "description": "Optional"
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "200",
            "content": {
              "application/json": {
                "examples": {
                  "Result": {
                    "value": {
                      "id": "6671c2de-2b33-4fdf-9141-dde1309471d7",
                      "state": "pending",
                      "stateReason": "pending_transactions",
                      "merchant": {
                        "id": "d560b17e-bae5-4fbf-8822-518273498c7a",
                        "name": "Demo payment merchant"
                      },
                      "subaccount": null,
                      "customer": {
                        "id": "3e1af0ab-1d14-495c-bb71-5c1f51ec5273"
                      },
                      "orderId": "123456",
                      "requested": {
                        "amount": "50",
                        "currency": "EUR"
                      },
                      "quoteCurrency": "USDC",
                      "quotes": [
                        {
                          "id": "59828126-c08a-48eb-99a6-51db80898d19",
                          "amount": "59.14",
                          "currency": "USDC",
                          "address": "0xD9259aF06b1b3302370fB1aC1b2B41Cb72D72000",
                          "tag": null,
                          "paymentUri": "ethereum:0x746d7b1dfcD1Cc2f4b7d09F3F1B9A21764FBeB33/transfer?address=0xD9259aF06b1b3302370fB1aC1b2B41Cb72D72000&uint256=59140000",
                          "extensions": {
                            "meshconnect": true
                          },
                          "payerWallet": {
                            "type": "vasp"
                          },
                          "expirationTime": "2026-03-12T15:53:44.040Z"
                        }
                      ],
                      "payments": [],
                      "merchantRefunds": [],
                      "redirects": {
                        "successUrl": "https://coinify.com",
                        "failureUrl": "https://www.google.com"
                      }
                    }
                  }
                },
                "schema": {
                  "type": "object",
                  "properties": {
                    "id": {
                      "type": "string",
                      "example": "eb88e36c-b118-480f-9ae9-f1de615a4049"
                    },
                    "orderId": {
                      "type": "string",
                      "example": "123456"
                    },
                    "state": {
                      "type": "string",
                      "example": "pending"
                    },
                    "stateReason": {
                      "type": "string",
                      "example": "pending_transactions"
                    },
                    "merchant": {
                      "type": "object",
                      "properties": {
                        "id": {
                          "type": "string",
                          "example": "f3f5c425-caa8-4a63-ba3c-9976f3cbfd80"
                        },
                        "name": {
                          "type": "string",
                          "example": "Demo Merchant"
                        }
                      }
                    },
                    "requested": {
                      "type": "object",
                      "properties": {
                        "amount": {
                          "type": "string",
                          "example": "99.99"
                        },
                        "currency": {
                          "type": "string",
                          "example": "EUR"
                        }
                      }
                    },
                    "quotes": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "properties": {
                          "id": {
                            "type": "string",
                            "example": "4fbb2718-fa75-40d5-9da7-4919ece76939"
                          },
                          "amount": {
                            "type": "string",
                            "example": "0.0052336"
                          },
                          "currency": {
                            "type": "string",
                            "example": "BTC"
                          },
                          "address": {
                            "type": "string",
                            "example": "2N9Qa1kYY1jBbCgV6xBR7RPHTMNxtGTJupB"
                          },
                          "tag": {},
                          "paymentUri": {
                            "type": "string",
                            "example": "bitcoin:2N9Qa1kYY1jBbCgV6xBR7RPHTMNxtGTJupB?amount=0.0052336"
                          },
                          "expirationTime": {
                            "type": "string",
                            "example": "2022-06-22T12:18:50.594Z"
                          }
                        }
                      }
                    },
                    "payments": {
                      "type": "array"
                    },
                    "merchantRefunds": {
                      "type": "array"
                    },
                    "redirects": {
                      "type": "object",
                      "properties": {
                        "successUrl": {
                          "type": "string",
                          "example": "https://www.merchant-eshop/success"
                        },
                        "failureUrl": {
                          "type": "string",
                          "example": "https://www.merchant-eshop/failure"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "400",
            "content": {
              "application/json": {
                "examples": {
                  "Result": {
                    "value": "{\n  \"errorCode\": \"invalid_request\",\n  \"errorMessage\": \"Can not create a quote for a payment intent while it is pending_confirmations\"\n  \"requestId\": \"0559cb6e-36f3-4cf6-b641-57af39600416\"\n}"
                  }
                },
                "schema": {
                  "oneOf": [
                    {
                      "type": "object",
                      "properties": {
                        "errorCode": {
                          "type": "string",
                          "example": "invalid_request"
                        },
                        "errorMessage": {
                          "type": "string",
                          "example": "Refund address is required for non-BTC quotes"
                        },
                        "requestId": {
                          "type": "string",
                          "example": "0559cb6e-36f3-4cf6-b641-57af39600416"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "properties": {
                        "errorCode": {
                          "type": "string",
                          "example": "invalid_request"
                        },
                        "errorMessage": {
                          "type": "string",
                          "example": "A descriptive error message"
                        },
                        "requestId": {
                          "type": "string",
                          "example": "{requestId}"
                        }
                      }
                    }
                  ]
                }
              }
            }
          },
          "404": {
            "description": "404",
            "content": {
              "application/json": {
                "examples": {
                  "Result": {
                    "value": "{\n  \"errorCode\": \"not_found\",\n  \"errorMessage\": \"PaymentIntent with ID id does not exist\",\n  \"requestId\": \"dde9bcfb-a32a-4a31-a250-92338a3f0603\"\n}"
                  }
                },
                "schema": {
                  "type": "object",
                  "properties": {
                    "errorCode": {
                      "type": "string",
                      "example": "not_found"
                    },
                    "errorMessage": {
                      "type": "string",
                      "example": "PaymentIntent with ID id does not exist"
                    },
                    "requestId": {
                      "type": "string",
                      "example": "dde9bcfb-a32a-4a31-a250-92338a3f0603"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "422",
            "content": {
              "application/json": {
                "examples": {
                  "Result": {
                    "value": "{\n  \"errorCode\": \"invalid_payload\",\n  \"errorMessage\": \"\\\"{property}\\\" is invalid\",\n  \"requestId\": \"{requestId}\"\n}"
                  }
                },
                "schema": {
                  "type": "object",
                  "properties": {
                    "errorCode": {
                      "type": "string",
                      "example": "invalid_payload"
                    },
                    "errorMessage": {
                      "type": "string",
                      "example": "\"{property}\" is invalid"
                    },
                    "requestId": {
                      "type": "string",
                      "example": "{requestId}"
                    }
                  }
                }
              }
            }
          }
        },
        "deprecated": false,
        "security": []
      }
    }
  },
  "x-readme": {
    "headers": [],
    "explorer-enabled": true,
    "proxy-enabled": true
  },
  "x-readme-fauxas": true
}
```